
#include <system.h>

#pragma CLOCK_FREQ 20000000
#pragma RS232_BAUD 9600

asm {
list p=16F688
__config H'30D2'
}

char val;
char mode;
char idx1;
char idx2;

char buf1[80];
char buf2[20];

void delay()
        {
        switch (mode & 0x0F)
                        {
                        case 1:break;
                        case 2:delay_us(5);break;
                        case 3:delay_us(45);break;
                        case 4:delay_us(200);delay_us(200);delay_us(100);break;
                        case 5:delay_ms(5);break;
                        case 6:delay_ms(50);break;
                        }
        }

void interrupt( void )
        {
        if ( pie1&0x40 && pir1&0x40 )
                        {
                        val=adresh;
                        idx2=idx1-80;
                        if (idx1>79) buf2[idx2]=val; else buf1[idx1]=val;
                        idx1++;
                        clear_bit( pir1, ADIF );
                        }

        if ( pir1&0x20 && pie1&0x20 )
                        {
                        mode=rcreg;
                        }
        }


void txreg_putch( char c )
{
        while( !(txsta&0x02) );
        txreg = c;
}


void on_init( void )
{
        option_reg = 0xFF;

        // IO ports setup
        ansel = 0x03;
        trisa = 0xFF;
        porta = 0x00;
        trisc = 0xF0;   // IIIIIOOO
        portc = 0x00;
        // rs232 communications setup
        spbrg = 32;       //9600
        txsta = 0x22;
        rcsta = 0x90;

        //ADC setup
        adcon0 = 0x41;
        adcon1 = 0x00;

        clear_bit( pir1, ADIF );
        set_bit( pie1, ADIE );

        set_bit( pie1, RCIE );

        enable_interrupt( PEIE );
        enable_interrupt( GIE );
}


main()
{
on_init();
mode=0;

char p;
set_bit(portc,0);
for (p=0;p<10;p++) delay_ms(100);
clear_bit(portc,0);

for (;;)
        {
        idx1=0;


        if (mode & 0x80) set_bit(portc,3);else clear_bit(portc,3);
        if (mode & 0x40) set_bit(portc,2);else clear_bit(portc,2);

        while (idx1<100)
                {
                set_bit(adcon0,1);
                delay();
                }

        if (mode)
                {
                set_bit(portc,0);
                txreg_putch(0xff);
                for (p=0;p<100;p++)
                    {
                    if (p>79) val=buf2[p-80]; else val=buf1[p];
                    if (val==0xff) val=0xfe;
                    txreg_putch(val);
                    }
                                delay_ms(1);
                clear_bit(portc,0);
                }
   }

}
